## rustc 1.71.1+dfsg0ubuntu2

=== debian/changelog ===
rustc (1.71.1+dfsg0ubuntu2-0ubuntu1) mantic; urgency=medium

  * Remove Windows libraries and dependencies
    (windows and windows-sys) (LP: #2036123)
    - d/p/d-0020-remove-windows-dependencies.patch,
      d/p/d-0021-vendor-remove-windows-dependencies.patch: add patches to
      remove references to Windows-specific libraries
    - d/copyright: Exclude all the removed libraries
    - d/control: Refresh dependency list

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 06 Sep 2023 16:41:39 -0600

rustc (1.71.1+dfsg0ubuntu1-0ubuntu2) mantic; urgency=medium

  * d/control: Fix an issue where the build dependency incorrectly specified
    the upper bound of rustc to <= 1.71.0 instead of 1.71.1 (LP: #2031545)

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 14 Aug 2023 12:03:34 +0800

rustc (1.71.1+dfsg0ubuntu1-0ubuntu1) mantic; urgency=medium

  * New upstream release 1.71.1 (LP: #2027942)
    - d/patches: Refresh patches
    - Upstream fixed CVE-2023-38497 and updated tar library
    - d/copyright: Update copyright information for upstream patched crates
  * d/p/u-reproducible-dl-stage0.patch,
    d/p/ubuntu-fix-sysroot-detection.patch,
    d/p/d-rustc-fix-mips64el-bootstrap.patch,
    d/p/d-bootstrap-read-beta-version-from-file.patch: Removed patches that
    were merged by the upstream
  * d/rules: Remove the src/tools/cargo/Cargo.lock file prior to the build, so
    that we can re-use the dependencies as many as possible
  * d/prune-unused-deps: Do the re-locking process for Cargo, since Cargo now
    also has its own workspace, it does not share the lock file with rustc
    starting in Rust 1.71
  * d/not-installed: Ignore backup files
  * d/cargo.bash-completion, d/not-installed: Fix the installation path for
    bash-completion files, the path has changed since Rust 1.71

 -- Zixing Liu <zixing.liu@canonical.com>  Sun, 06 Aug 2023 21:17:45 -0600

rustc (1.70.0+dfsg0ubuntu1-0ubuntu1) mantic; urgency=medium

  * New upstream release 1.70.0 (LP: #2027639)
    - d/patches: Refresh patches
    - Upgraded LLVM to 16
  * d/patches/d-0000-ignore-removed-submodules.patch: Remove newly added Miri
    parts
  * d/patches/ubuntu-downgrade-libgit2-to-1.5.patch: Downgrade libgit2
    requirements to 1.5, since we don't have 1.6 in stable yet
  * d/patches/d-0002-mdbook-strip-embedded-libs.patch: Remove newly added
    mdbook bundled resources
  * d/patches/ubuntu-use-system-compiler-during-tests.patch: Avoid the need of
    downloaded rustc binaries during the bootstrapping tests
  * d/rust-src.install: Fix the config.example.toml installation, because the
    file name changed in Rust 1.70
  * d/patches/ubuntu-disable-fpmath-tests-for-i386.patch: Disable a test for
    testing machine epsilon, which x87 math is too inaccurate to pass the test
  * d/source/lintian-overrides: update overriden paths for doc-tests

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 13 Jul 2023 17:07:11 +0800
