## rustc 1.73.0+dfsg0ubuntu1

=== debian/changelog ===
rustc (1.73.0+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.73.0 (LP: #2040340)
    - d/patches: Refresh patches
    - d/p/d-0021-vendor-remove-windows-dependencies.patch: remove new
      Windows dependencies
    - d/p/d-0020-remove-windows-dependencies.patch: remove references to macOS
      and Windows libraries in Cargo credential query logic
    - d/p/ubuntu-fix-short-ice-test.patch: remove obsoleted patch
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/control: bump Rust toolchain B-D requirements to 1.72
    - d/control: update the list of vendored dependencies
    - d/*: bump LLVM requirements to LLVM 17
    - d/s/lintian-overrides: suppress Lintian warnings about prebuilt Windows
      binaries in libloading-0.7.4. They are required by libloading for the tests
    - d/cargo.install: remove cargo-credential-1password plugin since now this
      functionality is builtin and no longer ships as a plugin

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 24 Oct 2023 22:29:46 -0600

rustc (1.72.1+dfsg0ubuntu1-0ubuntu1) mantic; urgency=medium

  * Cherry-pick new changes from Debian until Rust 1.70 (LP: #2041325)
    Applied:
    - Disable download tests
    - Fix internal cargo-doc links
    - Fix FTCBS by setting TARGET flags
    - Update privacy breach removal
    - Update Files-Excluded and unsuspicious files
    - Remove obsoleted patches
  * d/p/u-fix-get-toml-when-test.patch: removed. This conflicts both on
    functionalities and compatibilities with other Ubuntu patches.
  * New upstream release 1.72.1 (LP: #2040339)
    - d/patches: Refresh patches
    - d/p/d-0000-ignore-removed-submodules.patch: Remove Windows-specific
      submodule
    - d/p/d-0021-vendor-remove-windows-dependencies.patch: Remove
      new Windows dependencies
    - d/p/ubuntu-fix-short-ice-test.patch: Add a patch to fix short-ice test
    - d/copyright:
      - Update copyright information for upstream patched crates
      - Update excluded dependencies list
      - Remove windows-bindgen module
    - d/control: Update vendored dependency list
    - d/control: update libgit2 B-D requirements to 1.7
    - d/s/lintian-overrides: Remove unused overrides
  * Remove fonts-nanum from the dependencies (LP: #2031685)
    - d/p/ubuntu-disable-nanum-fonts.patch: Add a patch to disable and remove
      references to the Nanum fonts. We have Noto Sans CJK in the system.
    - d/control: Remove fonts-nanum from the dependencies

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 11 Oct 2023 14:46:37 -0600
