=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,13 @@
 LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')
 
 include /usr/share/dpkg/buildflags.mk
-export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
+# needed for cross-compilation to avoid passing host CFLAGS to the BUILD
+# compiler
+export TARGET_CFLAGS = $(CFLAGS)
+export TARGET_CXXFLAGS = $(CXXFLAGS)
+export TARGET_CPPFLAGS = $(CPPFLAGS)
+export TARGET_LDFLAGS = $(LDFLAGS)
+unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
 export CARGO_HOME = $(CURDIR)/debian/cargo
 
 # Defines DEB_*_RUST_TYPE triples
@@ -32,8 +38,8 @@
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
 # Use system LLVM (comment out to use vendored LLVM)
-LLVM_VERSION = 16
-OLD_LLVM_VERSION = 15
+LLVM_VERSION = 17
+OLD_LLVM_VERSION = 16
 # used by the patched profiler build script
 CLANG_RT_ARCH := $(DEB_TARGET_GNU_CPU)
 ifeq (i386,$(DEB_TARGET_ARCH))
@@ -201,6 +207,3 @@
 		-DLLVM_VERSION="$(LLVM_VERSION)" \
 		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
 		"$<" > "$@"
-	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
-	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
-# Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
