## rustc 1.74.1+dfsg0ubuntu1

=== debian/changelog ===
rustc (1.74.1+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.74.1 (LP: #2044036)
    - d/patches: Refresh patches
    - d/p/d-0021-vendor-remove-windows-dependencies.patch: remove new
      Windows dependencies
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data and add LGPL 2.1 license texts
    - d/p/d-fix-rustix-outline.patch: re-add rustix fix for 1.74
    - d/p/ubuntu-upgrade-libgit2-to-1.7.patch: remove obsoleted patch
    - d/libstd-rust-*: bump version to 1.74
    - d/rules: apply a workaround to avoid dh_dwz complaining about
      "Too many DIEs, not optimizing"

 -- Zixing Liu <zixing.liu@canonical.com>  Sun, 19 Nov 2023 18:04:52 -0700
