=== debian/control ===
--- 
+++ 
@@ -15,9 +15,9 @@
  dh-cargo (>= 28ubuntu1~),
  dpkg-dev (>= 1.17.14),
  python3:native,
- cargo:native (>= 1.72.0+dfsg) <!pkg.rustc.dlstage0>,
- rustc:native (>= 1.72.0+dfsg) <!pkg.rustc.dlstage0>,
- rustc:native (<= 1.73.1++)    <!pkg.rustc.dlstage0>,
+ cargo:native (>= 1.73.0+dfsg) <!pkg.rustc.dlstage0>,
+ rustc:native (>= 1.73.0+dfsg) <!pkg.rustc.dlstage0>,
+ rustc:native (<= 1.74.1++)    <!pkg.rustc.dlstage0>,
  llvm-17-dev:native,
  llvm-17-tools:native,
  libclang-rt-17-dev (>= 1:17.0.2),
