=== tests/run-make/valid-print-requests/Makefile ===
include ../tools.mk

all:
	$(RUSTC) --print uwu 2>&1 | diff - valid-print-requests.stderr
