=== src/llvm-project/lldb/source/Plugins/Instruction/PPC64/CMakeLists.txt ===
add_lldb_library(lldbPluginInstructionPPC64 PLUGIN
  EmulateInstructionPPC64.cpp

  LINK_LIBS
    lldbCore
    lldbInterpreter
    lldbSymbol
    lldbPluginProcessUtility
  LINK_COMPONENTS
    Support
  )
