=== debian/changelog ===
rustc (1.75.0+dfsg0ubuntu1~bpo0-0ubuntu0.20.04) focal; urgency=medium

  * Backport to Focal (LP: #2047858)
    - d/p/ubuntu-backport-disable-newer-tests.patch: add a patch to disable
      newer tests that can't pass on older Ubuntu series
    - d/p/ubuntu-jammy-skip-gdb-tests-on-armhf.patch: add a patch to
      disable gdb tests on armhf
    - Re-enable libgit2 vendoring:
      - d/control: remove libgit2-dev and libhttp-parser-dev from B-D
    - Re-enable LLVM vendoring (LLVM 17)
    - d/p/ubuntu-backport-disable-newer-tests.patch: disable tests that
      can't pass on older series
    - d/control: Comment out the Vendored-Sources-Rust support as it's not
      available in older releases
    - Downgrade debhelper requirements and adapt the build files to
      older debhelper standards
    - d/control: Use cmake-mozilla instead of cmake on Focal
    - d/p/ubuntu-llvm-riscv-disable-zicsr.patch: fix build on RISC-V

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 14 Feb 2024 15:09:28 -0700

rustc (1.75.0+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.75.0 (LP: #2047858)
    - d/patches: Refresh patches
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/libstd-rust-*: bump version to 1.75
    - d/patches: remove obsoleted patches
    - d/s/lintian-overrides: update lintian overrides
    - d/control: update vendored crate list

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 02 Jan 2024 12:09:03 -0700
